]> git.ipfire.org Git - people/ummeegge/ipfire-2.x.git/blob - make.sh
OpenVPN-DCO-OpenSSL3: Updates for OpenVPN-2.6.0 and OpenSSL-3.0.8
[people/ummeegge/ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ###############################################################################
3 # #
4 # IPFire.org - A linux based firewall #
5 # Copyright (C) 2007-2022 IPFire Team <info@ipfire.org> #
6 # #
7 # This program is free software: you can redistribute it and/or modify #
8 # it under the terms of the GNU General Public License as published by #
9 # the Free Software Foundation, either version 3 of the License, or #
10 # (at your option) any later version. #
11 # #
12 # This program is distributed in the hope that it will be useful, #
13 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
15 # GNU General Public License for more details. #
16 # #
17 # You should have received a copy of the GNU General Public License #
18 # along with this program. If not, see <http://www.gnu.org/licenses/>. #
19 # #
20 ###############################################################################
21
22 NAME="IPFire" # Software name
23 SNAME="ipfire" # Short name
24 # If you update the version don't forget to update backupiso and add it to core update
25 VERSION="2.27" # Version number
26 CORE="174" # Core Level (Filename)
27 SLOGAN="www.ipfire.org" # Software slogan
28 CONFIG_ROOT=/var/ipfire # Configuration rootdir
29 MAX_RETRIES=1 # prefetch/check loop
30 BUILD_IMAGES=1 # Flash and Xen Downloader
31 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
32
33 # Information from Git
34 GIT_BRANCH="$(git rev-parse --abbrev-ref HEAD)" # Git Branch
35 GIT_TAG="$(git tag | tail -1)" # Git Tag
36 GIT_LASTCOMMIT="$(git rev-parse --verify HEAD)" # Last commit
37
38 TOOLCHAINVER=20230210
39
40 # use multicore and max compression
41 ZSTD_OPT="-T0 --ultra -22"
42
43 ###############################################################################
44 #
45 # Beautifying variables & presentation & input output interface
46 #
47 ###############################################################################
48
49 # Remember if the shell is interactive or not
50 if [ -t 0 ] && [ -t 1 ]; then
51 INTERACTIVE=true
52 else
53 INTERACTIVE=false
54 fi
55
56 # Sets or adjusts pretty formatting variables
57 resize_terminal() {
58 ## Screen Dimentions
59 # Find current screen size
60 COLUMNS=$(tput cols)
61
62 # When using remote connections, such as a serial port, stty size returns 0
63 if ! ${INTERACTIVE} || [ "${COLUMNS}" = "0" ]; then
64 COLUMNS=80
65 fi
66
67 # Measurements for positioning result messages
68 OPTIONS_WIDTH=20
69 TIME_WIDTH=12
70 STATUS_WIDTH=8
71 NAME_WIDTH=$(( COLUMNS - OPTIONS_WIDTH - TIME_WIDTH - STATUS_WIDTH ))
72 LINE_WIDTH=$(( COLUMNS - STATUS_WIDTH ))
73
74 TIME_COL=$(( NAME_WIDTH + OPTIONS_WIDTH ))
75 STATUS_COL=$(( TIME_COL + TIME_WIDTH ))
76 }
77
78 # Initially setup terminal
79 resize_terminal
80
81 # Call resize_terminal when terminal is being resized
82 trap "resize_terminal" WINCH
83
84 # Define color for messages
85 BOLD="\\033[1;39m"
86 DONE="\\033[1;32m"
87 SKIP="\\033[1;34m"
88 WARN="\\033[1;35m"
89 FAIL="\\033[1;31m"
90 NORMAL="\\033[0;39m"
91
92 # New architecture variables
93 HOST_ARCH="$(uname -m)"
94
95 PWD=$(pwd)
96 BASENAME=$(basename $0)
97
98 # Debian specific settings
99 if [ ! -e /etc/debian_version ]; then
100 FULLPATH=`which $0`
101 else
102 if [ -x /usr/bin/realpath ]; then
103 FULLPATH=`/usr/bin/realpath $0`
104 else
105 echo "ERROR: Need to do apt-get install realpath"
106 exit 1
107 fi
108 fi
109
110 # This is the directory where make.sh is in
111 export BASEDIR=$(echo $FULLPATH | sed "s/\/$BASENAME//g")
112
113 LOGFILE=$BASEDIR/log/_build.preparation.log
114 export LOGFILE
115 DIR_CHK=$BASEDIR/cache/check
116 mkdir $BASEDIR/log/ 2>/dev/null
117
118 system_processors() {
119 getconf _NPROCESSORS_ONLN 2>/dev/null || echo "1"
120 }
121
122 system_memory() {
123 local key val unit
124
125 while read -r key val unit; do
126 case "${key}" in
127 MemTotal:*)
128 # Convert to MB
129 echo "$(( ${val} / 1024 ))"
130 break
131 ;;
132 esac
133 done < /proc/meminfo
134 }
135
136 configure_build() {
137 local build_arch="${1}"
138
139 if [ "${build_arch}" = "default" ]; then
140 build_arch="$(configure_build_guess)"
141 fi
142
143 case "${build_arch}" in
144 x86_64)
145 BUILDTARGET="${build_arch}-pc-linux-gnu"
146 CROSSTARGET="${build_arch}-cross-linux-gnu"
147 BUILD_PLATFORM="x86"
148 CFLAGS_ARCH="-m64 -mtune=generic -fcf-protection"
149 ;;
150
151 aarch64)
152 BUILDTARGET="${build_arch}-pc-linux-gnu"
153 CROSSTARGET="${build_arch}-cross-linux-gnu"
154 BUILD_PLATFORM="arm"
155 CFLAGS_ARCH=""
156 ;;
157
158 riscv64)
159 BUILDTARGET="${build_arch}-pc-linux-gnu"
160 CROSSTARGET="${build_arch}-cross-linux-gnu"
161 BUILD_PLATFORM="riscv"
162 CFLAGS_ARCH=""
163 ;;
164
165 *)
166 exiterror "Cannot build for architure ${build_arch}"
167 ;;
168 esac
169
170 # Check if the QEMU helper is available if needed.
171 if qemu_is_required "${build_arch}"; then
172 local qemu_build_helper="$(qemu_find_build_helper_name "${build_arch}")"
173
174 if [ -n "${qemu_build_helper}" ]; then
175 QEMU_TARGET_HELPER="${qemu_build_helper}"
176 else
177 exiterror "Could not find a binfmt_misc helper entry for ${build_arch}"
178 fi
179 fi
180
181 BUILD_ARCH="${build_arch}"
182 TOOLS_DIR="/tools_${BUILD_ARCH}"
183
184 # Enables hardening
185 HARDENING_CFLAGS="-Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS -fstack-protector-strong -fstack-clash-protection"
186
187 CFLAGS="-O2 -pipe -Wall -fexceptions -fPIC ${CFLAGS_ARCH}"
188 CXXFLAGS="${CFLAGS}"
189
190 RUSTFLAGS="-Copt-level=3 -Clink-arg=-Wl,-z,relro,-z,now -Ccodegen-units=1 --cap-lints=warn ${RUSTFLAGS_ARCH}"
191
192 # Determine parallelism
193 # We assume that each process consumes about
194 # 128MB of memory. Therefore we find out how
195 # many processes fit into memory.
196 local mem_max=$(( ${SYSTEM_MEMORY} / 128 ))
197 local cpu_max=$(( ${SYSTEM_PROCESSORS} ))
198
199 local parallelism
200 if [ ${mem_max} -lt ${cpu_max} ]; then
201 parallelism=${mem_max}
202 else
203 parallelism=${cpu_max}
204 fi
205
206 # Use this as default PARALLELISM
207 DEFAULT_PARALLELISM="${parallelism}"
208
209 # Limit lauched ninja build jobs to computed parallel value.
210 NINJAJOBS="${parallelism}"
211
212 # Compression parameters
213 # We use mode 8 for reasonable memory usage when decompressing
214 # but with overall good compression
215 XZ_OPT="-8"
216
217 # We try to use as many cores as possible
218 XZ_OPT="${XZ_OPT} -T0"
219
220 # We need to limit memory because XZ uses too much when running
221 # in parallel and it isn't very smart in limiting itself.
222 # We allow XZ to use up to 70% of all system memory.
223 local xz_memory=$(( SYSTEM_MEMORY * 7 / 10 ))
224
225 XZ_OPT="${XZ_OPT} --memory=${xz_memory}MiB"
226 }
227
228 configure_build_guess() {
229 case "${HOST_ARCH}" in
230 x86_64)
231 echo "x86_64"
232 ;;
233
234 aarch64)
235 echo "aarch64"
236 ;;
237
238 riscv64)
239 echo "riscv64"
240 ;;
241
242 *)
243 exiterror "Cannot guess build architecture"
244 ;;
245 esac
246 }
247
248 stdumount() {
249 umount $BASEDIR/build/sys 2>/dev/null;
250 umount $BASEDIR/build/dev/shm 2>/dev/null;
251 umount $BASEDIR/build/dev/pts 2>/dev/null;
252 umount $BASEDIR/build/dev 2>/dev/null;
253 umount $BASEDIR/build/proc 2>/dev/null;
254 umount $BASEDIR/build/install/mnt 2>/dev/null;
255 umount $BASEDIR/build/usr/src/cache 2>/dev/null;
256 umount $BASEDIR/build/usr/src/ccache 2>/dev/null;
257 umount $BASEDIR/build/usr/src/config 2>/dev/null;
258 umount $BASEDIR/build/usr/src/doc 2>/dev/null;
259 umount $BASEDIR/build/usr/src/html 2>/dev/null;
260 umount $BASEDIR/build/usr/src/langs 2>/dev/null;
261 umount $BASEDIR/build/usr/src/lfs 2>/dev/null;
262 umount $BASEDIR/build/usr/src/log 2>/dev/null;
263 umount $BASEDIR/build/usr/src/src 2>/dev/null;
264 umount $BASEDIR/build/usr/src 2>/dev/null;
265 umount $BASEDIR/build/tmp 2>/dev/null;
266 }
267
268 format_runtime() {
269 local seconds=${1}
270
271 if [ ${seconds} -ge 3600 ]; then
272 printf "%d:%02d:%02d\n" \
273 "$(( seconds / 3600 ))" \
274 "$(( seconds % 3600 / 60 ))" \
275 "$(( seconds % 3600 % 60 ))"
276 elif [ ${seconds} -ge 60 ]; then
277 printf "%d:%02d\n" \
278 "$(( seconds / 60 ))" \
279 "$(( seconds % 60 ))"
280 else
281 printf "%d\n" "${seconds}"
282 fi
283 }
284
285 print_line() {
286 local line="$@"
287
288 printf "%-${LINE_WIDTH}s" "${line}"
289 }
290
291 _print_line() {
292 local status="${1}"
293 shift
294
295 if ${INTERACTIVE}; then
296 printf "${!status}"
297 fi
298
299 print_line "$@"
300
301 if ${INTERACTIVE}; then
302 printf "${NORMAL}"
303 fi
304 }
305
306 print_headline() {
307 _print_line BOLD "$@"
308 }
309
310 print_error() {
311 _print_line FAIL "$@"
312 }
313
314 print_package() {
315 local name="${1}"
316 shift
317
318 local version="$(grep -E "^VER |^VER=|^VER " $BASEDIR/lfs/${name} | awk '{ print $3 }')"
319 local options="$@"
320
321 local string="${name}"
322 if [ -n "${version}" ] && [ "${version}" != "ipfire" ]; then
323 string="${string} (${version})"
324 fi
325
326 printf "%-$(( ${NAME_WIDTH} - 1 ))s " "${string}"
327 printf "%$(( ${OPTIONS_WIDTH} - 1 ))s " "${options}"
328 }
329
330 print_runtime() {
331 local runtime=$(format_runtime $@)
332
333 if ${INTERACTIVE}; then
334 printf "\\033[${TIME_COL}G[ ${BOLD}%$(( ${TIME_WIDTH} - 4 ))s${NORMAL} ]" "${runtime}"
335 else
336 printf "[ %$(( ${TIME_WIDTH} - 4 ))s ]" "${runtime}"
337 fi
338 }
339
340 print_status() {
341 local status="${1}"
342
343 local color="${!status}"
344
345 if ${INTERACTIVE}; then
346 printf "\\033[${STATUS_COL}G[${color-${BOLD}} %-$(( ${STATUS_WIDTH} - 4 ))s ${NORMAL}]\n" "${status}"
347 else
348 printf "[ %-$(( ${STATUS_WIDTH} - 4 ))s ]\n" "${status}"
349 fi
350 }
351
352 print_build_stage() {
353 print_headline "$@"
354
355 # end line
356 printf "\n"
357 }
358
359 print_build_summary() {
360 local runtime=$(format_runtime $@)
361
362 print_line "*** Build finished in ${runtime}"
363 print_status DONE
364 }
365
366 exiterror() {
367 stdumount
368 for i in `seq 0 7`; do
369 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
370 losetup -d /dev/loop${i} 2>/dev/null
371 fi;
372 done
373
374 # Dump logfile
375 if [ -n "${LOGFILE}" ] && [ -e "${LOGFILE}" ]; then
376 echo # empty line
377
378 local line
379 while read -r line; do
380 echo " ${line}"
381 done <<< "$(tail -n30 ${LOGFILE})"
382 fi
383
384 echo # empty line
385
386 local line
387 for line in "ERROR: $@" " Check ${LOGFILE} for errors if applicable"; do
388 print_error "${line}"
389 print_status FAIL
390 done
391
392 exit 1
393 }
394
395 prepareenv() {
396 # Are we running the right shell?
397 if [ -z "${BASH}" ]; then
398 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
399 fi
400
401 if [ -z "${BASH_VERSION}" ]; then
402 exiterror "Not running BASH shell."
403 fi
404
405 # Trap on emergency exit
406 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGQUIT
407
408 # Checking if running as root user
409 if [ $(id -u) -ne 0 ]; then
410 exiterror "root privileges required for building"
411 fi
412
413 # Checking for necessary temporary space
414 print_line "Checking for necessary space on disk $BASE_DEV"
415 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
416 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
417 if (( 2048000 > $BASE_ASPACE )); then
418 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
419 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
420 print_status FAIL
421 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
422 fi
423 else
424 print_status DONE
425 fi
426
427 # Set umask
428 umask 022
429
430 # Set LFS Directory
431 LFS=$BASEDIR/build
432
433 # Setup environment
434 set +h
435 LC_ALL=POSIX
436 export LFS LC_ALL CFLAGS CXXFLAGS DEFAULT_PARALLELISM RUSTFLAGS NINJAJOBS
437 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
438
439 # Make some extra directories
440 mkdir -p "${BASEDIR}/build${TOOLS_DIR}" 2>/dev/null
441 mkdir -p $BASEDIR/build/{etc,usr/src} 2>/dev/null
442 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
443 mkdir -p $BASEDIR/{cache,ccache/${BUILD_ARCH}/${TOOLCHAINVER}} 2>/dev/null
444
445 if [ "${ENABLE_RAMDISK}" = "on" ]; then
446 mkdir -p $BASEDIR/build/usr/src
447 mount -t tmpfs tmpfs -o size=8G,nr_inodes=1M,mode=1777 $BASEDIR/build/usr/src
448
449 mkdir -p ${BASEDIR}/build/tmp
450 mount -t tmpfs tmpfs -o size=4G,nr_inodes=1M,mode=1777 ${BASEDIR}/build/tmp
451 fi
452
453 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
454
455 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
456 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
457
458 # Make all sources and proc available under lfs build
459 mount --bind /dev $BASEDIR/build/dev
460 mount --bind /dev/pts $BASEDIR/build/dev/pts
461 mount --bind /dev/shm $BASEDIR/build/dev/shm
462 mount --bind /proc $BASEDIR/build/proc
463 mount --bind /sys $BASEDIR/build/sys
464 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
465 mount --bind $BASEDIR/ccache/${BUILD_ARCH}/${TOOLCHAINVER} $BASEDIR/build/usr/src/ccache
466 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
467 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
468 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
469 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
470 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
471 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
472 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
473
474 # Run LFS static binary creation scripts one by one
475 export CCACHE_DIR=$BASEDIR/ccache
476 export CCACHE_TEMPDIR="/tmp"
477 export CCACHE_COMPILERCHECK="string:toolchain-${TOOLCHAINVER} ${BUILD_ARCH}"
478
479 # Remove pre-install list of installed files in case user erase some files before rebuild
480 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
481
482 # Prepare string for /etc/system-release.
483 local system_release="${NAME} ${VERSION} (${BUILD_ARCH})"
484
485 case "${GIT_BRANCH}" in
486 core*|beta?|rc?)
487 system_release="${system_release} - ${GIT_BRANCH}"
488 ;;
489 *)
490 system_release="${system_release} - core${CORE} Development Build: ${GIT_BRANCH}/${GIT_LASTCOMMIT:0:8}"
491 ;;
492 esac
493
494 # Append -dirty tag for local changes
495 if [ "$(git status -s | wc -l)" != "0" ]; then
496 system_release="${system_release}-dirty"
497 fi
498
499 # Export variable
500 SYSTEM_RELEASE="${system_release}"
501
502 # Decide on PAKFIRE_TREE
503 case "${GIT_BRANCH}" in
504 core*)
505 PAKFIRE_TREE="stable"
506 ;;
507 master)
508 PAKFIRE_TREE="testing"
509 ;;
510 *)
511 PAKFIRE_TREE="unstable"
512 ;;
513 esac
514
515 # Setup ccache cache size
516 enterchroot ccache --max-size="${CCACHE_CACHE_SIZE}"
517 }
518
519 enterchroot() {
520 # Install QEMU helper, if needed
521 qemu_install_helper
522
523 local PATH="${TOOLS_DIR}/ccache/bin:/bin:/usr/bin:/sbin:/usr/sbin:${TOOLS_DIR}/sbin:${TOOLS_DIR}/bin"
524
525 # Prepend any custom changes to PATH
526 if [ -n "${CUSTOM_PATH}" ]; then
527 PATH="${CUSTOM_PATH}:${PATH}"
528 fi
529
530 PATH="${PATH}" chroot ${LFS} env -i \
531 HOME="/root" \
532 TERM="${TERM}" \
533 PS1="${PS1}" \
534 PATH="${PATH}" \
535 SYSTEM_RELEASE="${SYSTEM_RELEASE}" \
536 PAKFIRE_TREE="${PAKFIRE_TREE}" \
537 NAME="${NAME}" \
538 SNAME="${SNAME}" \
539 VERSION="${VERSION}" \
540 CORE="${CORE}" \
541 SLOGAN="${SLOGAN}" \
542 TOOLS_DIR="${TOOLS_DIR}" \
543 CONFIG_ROOT="${CONFIG_ROOT}" \
544 CFLAGS="${CFLAGS} ${HARDENING_CFLAGS}" \
545 CXXFLAGS="${CXXFLAGS} ${HARDENING_CFLAGS}" \
546 RUSTFLAGS="${RUSTFLAGS}" \
547 BUILDTARGET="${BUILDTARGET}" \
548 CROSSTARGET="${CROSSTARGET}" \
549 BUILD_ARCH="${BUILD_ARCH}" \
550 BUILD_PLATFORM="${BUILD_PLATFORM}" \
551 CCACHE_DIR=/usr/src/ccache \
552 CCACHE_TEMPDIR="${CCACHE_TEMPDIR}" \
553 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
554 GOCACHE="/usr/src/ccache/go" \
555 KVER="${KVER}" \
556 XZ_OPT="${XZ_OPT}" \
557 DEFAULT_PARALLELISM="${DEFAULT_PARALLELISM}" \
558 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
559 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
560 $(fake_environ) \
561 $(qemu_environ) \
562 "$@"
563 }
564
565 entershell() {
566 if [ ! -e $BASEDIR/build/usr/src/lfs/ ]; then
567 exiterror "No such file or directory: $BASEDIR/build/usr/src/lfs/"
568 fi
569
570 echo "Entering to a shell inside LFS chroot, go out with exit"
571 local PS1="ipfire build chroot (${BUILD_ARCH}) \u:\w\$ "
572
573 if enterchroot bash -i; then
574 stdumount
575 else
576 print_status FAIL
577 exiterror "chroot error"
578 fi
579 }
580
581 lfsmakecommoncheck() {
582 # Script present?
583 if [ ! -f $BASEDIR/lfs/$1 ]; then
584 exiterror "No such file or directory: $BASEDIR/$1"
585 fi
586
587 # Print package name and version
588 print_package $@
589
590 # Check if this package is supported by our architecture.
591 # If no SUP_ARCH is found, we assume the package can be built for all.
592 if grep "^SUP_ARCH" ${BASEDIR}/lfs/${1} >/dev/null; then
593 # Check if package supports ${BUILD_ARCH} or all architectures.
594 if ! grep -E "^SUP_ARCH.*${BUILD_ARCH}|^SUP_ARCH.*all" ${BASEDIR}/lfs/${1} >/dev/null; then
595 print_runtime 0
596 print_status SKIP
597 return 1
598 fi
599 fi
600
601 # Script slipped?
602 local i
603 for i in $SKIP_PACKAGE_LIST
604 do
605 if [ "$i" == "$1" ]; then
606 print_status SKIP
607 return 1;
608 fi
609 done
610
611 echo -ne "`date -u '+%b %e %T'`: Building $* " >> $LOGFILE
612
613 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
614 MESSAGE="$1\t " download >> $LOGFILE 2>&1
615 if [ $? -ne 0 ]; then
616 exiterror "Download error in $1"
617 fi
618
619 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
620 MESSAGE="$1\t b2sum" b2 >> $LOGFILE 2>&1
621 if [ $? -ne 0 ]; then
622 exiterror "BLAKE2 checksum error in $1, check file in cache or signature"
623 fi
624
625 return 0 # pass all!
626 }
627
628 lfsmake1() {
629 lfsmakecommoncheck $*
630 [ $? == 1 ] && return 0
631
632 # Set PATH to use the toolchain tools first and then whatever the host has set
633 local PATH="${TOOLS_DIR}/ccache/bin:${TOOLS_DIR}/sbin:${TOOLS_DIR}/bin:${PATH}"
634
635 if [ -n "${CUSTOM_PATH}" ]; then
636 PATH="${CUSTOM_PATH}:${PATH}"
637 fi
638
639 cd $BASEDIR/lfs && env -i \
640 PATH="${PATH}" \
641 CCACHE_DIR="${CCACHE_DIR}"/${BUILD_ARCH}/${TOOLCHAINVER} \
642 CCACHE_TEMPDIR="${CCACHE_TEMPDIR}" \
643 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
644 CFLAGS="${CFLAGS}" \
645 CXXFLAGS="${CXXFLAGS}" \
646 DEFAULT_PARALLELISM="${DEFAULT_PARALLELISM}" \
647 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
648 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
649 make -f $* \
650 TOOLCHAIN=1 \
651 TOOLS_DIR="${TOOLS_DIR}" \
652 CROSSTARGET="${CROSSTARGET}" \
653 BUILDTARGET="${BUILDTARGET}" \
654 BUILD_ARCH="${BUILD_ARCH}" \
655 BUILD_PLATFORM="${BUILD_PLATFORM}" \
656 LFS_BASEDIR="${BASEDIR}" \
657 ROOT="${LFS}" \
658 KVER="${KVER}" \
659 install >> $LOGFILE 2>&1 &
660
661 if ! wait_until_finished $!; then
662 print_status FAIL
663 exiterror "Building $*"
664 fi
665
666 print_status DONE
667 }
668
669 lfsmake2() {
670 lfsmakecommoncheck $*
671 [ $? == 1 ] && return 0
672
673 local PS1='\u:\w$ '
674
675 enterchroot \
676 bash -x -c "cd /usr/src/lfs && \
677 make -f $* \
678 LFS_BASEDIR=/usr/src install" \
679 >> ${LOGFILE} 2>&1 &
680
681 if ! wait_until_finished $!; then
682 print_status FAIL
683 exiterror "Building $*"
684 fi
685
686 print_status DONE
687 }
688
689 ipfiredist() {
690 lfsmakecommoncheck $*
691 [ $? == 1 ] && return 0
692
693 local PS1='\u:\w$ '
694
695 enterchroot \
696 bash -x -c "cd /usr/src/lfs && make -f $* LFS_BASEDIR=/usr/src dist" \
697 >> ${LOGFILE} 2>&1 &
698
699 if ! wait_until_finished $!; then
700 print_status FAIL
701 exiterror "Packaging $*"
702 fi
703
704 print_status DONE
705 }
706
707 wait_until_finished() {
708 local pid=${1}
709
710 local start_time="${SECONDS}"
711
712 # Show progress
713 if ${INTERACTIVE}; then
714 # Wait a little just in case the process
715 # has finished very quickly.
716 sleep 0.1
717
718 local runtime
719 while kill -0 ${pid} 2>/dev/null; do
720 print_runtime $(( SECONDS - start_time ))
721
722 # Wait a little
723 sleep 1
724 done
725 fi
726
727 # Returns the exit code of the child process
728 wait ${pid}
729 local ret=$?
730
731 if ! ${INTERACTIVE}; then
732 print_runtime $(( SECONDS - start_time ))
733 fi
734
735 return ${ret}
736 }
737
738 fake_environ() {
739 [ -e "${BASEDIR}/build${TOOLS_DIR}/lib/libpakfire_preload.so" ] || return
740
741 local env="LD_PRELOAD=${TOOLS_DIR}/lib/libpakfire_preload.so"
742
743 # Fake kernel version, because some of the packages do not compile
744 # with kernel 3.0 and later.
745 env="${env} UTS_RELEASE=${KVER}-ipfire"
746
747 # Fake machine version.
748 env="${env} UTS_MACHINE=${BUILD_ARCH}"
749
750 echo "${env}"
751 }
752
753 qemu_environ() {
754 local env="QEMU_TARGET_HELPER=${QEMU_TARGET_HELPER}"
755
756 # Don't add anything if qemu is not used.
757 if ! qemu_is_required; then
758 return
759 fi
760
761 # Set default qemu options
762 case "${BUILD_ARCH}" in
763 arm*)
764 QEMU_CPU="${QEMU_CPU:-cortex-a9}"
765
766 env="${env} QEMU_CPU=${QEMU_CPU}"
767 ;;
768 riscv64)
769 QEMU_CPU="${QEMU_CPU:-sifive-u54}"
770
771 env="${env} QEMU_CPU=${QEMU_CPU}"
772 ;;
773 esac
774
775 # Enable QEMU strace
776 #env="${env} QEMU_STRACE=1"
777
778 echo "${env}"
779 }
780
781 qemu_is_required() {
782 local build_arch="${1}"
783
784 if [ -z "${build_arch}" ]; then
785 build_arch="${BUILD_ARCH}"
786 fi
787
788 case "${HOST_ARCH},${build_arch}" in
789 x86_64,arm*|x86_64,aarch64|x86_64,riscv64|i?86,arm*|i?86,aarch64|i?86,x86_64)
790 return 0
791 ;;
792 *)
793 return 1
794 ;;
795 esac
796 }
797
798 qemu_install_helper() {
799 # Do nothing, if qemu is not required
800 if ! qemu_is_required; then
801 return 0
802 fi
803
804 if [ ! -e /proc/sys/fs/binfmt_misc/status ]; then
805 exiterror "binfmt_misc not mounted. QEMU_TARGET_HELPER not useable."
806 fi
807
808 if [ ! $(cat /proc/sys/fs/binfmt_misc/status) = 'enabled' ]; then
809 exiterror "binfmt_misc not enabled. QEMU_TARGET_HELPER not useable."
810 fi
811
812
813 if [ -z "${QEMU_TARGET_HELPER}" ]; then
814 exiterror "QEMU_TARGET_HELPER not set"
815 fi
816
817 # Check if the helper is already installed.
818 if [ -x "${LFS}${QEMU_TARGET_HELPER}" ]; then
819 return 0
820 fi
821
822 # Try to find a suitable binary that we can install
823 # to the build environment.
824 local file
825 for file in "${QEMU_TARGET_HELPER}" "${QEMU_TARGET_HELPER}-static"; do
826 # file must exist and be executable.
827 [ -x "${file}" ] || continue
828
829 # Must be static.
830 file_is_static "${file}" || continue
831
832 local dirname="${LFS}$(dirname "${file}")"
833 mkdir -p "${dirname}"
834
835 install -m 755 "${file}" "${LFS}${QEMU_TARGET_HELPER}"
836 return 0
837 done
838
839 exiterror "Could not find a statically-linked QEMU emulator: ${QEMU_TARGET_HELPER}"
840 }
841
842 qemu_find_build_helper_name() {
843 local build_arch="${1}"
844
845 local magic
846 case "${build_arch}" in
847 aarch64)
848 magic="7f454c460201010000000000000000000200b700"
849 ;;
850 arm*)
851 magic="7f454c4601010100000000000000000002002800"
852 ;;
853 riscv64)
854 magic="7f454c460201010000000000000000000200f300"
855 ;;
856 x86_64)
857 magic="7f454c4602010100000000000000000002003e00"
858 ;;
859 esac
860
861 [ -z "${magic}" ] && return 1
862
863 local file
864 for file in /proc/sys/fs/binfmt_misc/*; do
865 # skip write only register entry
866 [ $(basename "${file}") = "register" ] && continue
867 # Search for the file with the correct magic value.
868 grep -qE "^magic ${magic}$" "${file}" || continue
869
870 local interpreter="$(grep "^interpreter" "${file}" | awk '{ print $2 }')"
871
872 [ -n "${interpreter}" ] || continue
873 [ "${interpreter:0:1}" = "/" ] || continue
874 [ -x "${interpreter}" ] || continue
875
876 echo "${interpreter}"
877 return 0
878 done
879
880 return 1
881 }
882
883 file_is_static() {
884 local file="${1}"
885
886 file -L "${file}" 2>/dev/null | grep -q -e "statically linked" -e "static-pie linked"
887 }
888
889 update_language_list() {
890 local path="${1}"
891
892 local lang
893 for lang in ${path}/*.po; do
894 lang="$(basename "${lang}")"
895 echo "${lang%*.po}"
896 done | sort -u > "${path}/LINGUAS"
897 }
898
899 contributors() {
900 local commits name
901
902 git shortlog --summary --numbered | while read -r commits name; do
903 echo "${name}"
904 done | grep -vE -e "^(alpha197|morlix|root|ummeegge)$" -e "via Development$" -e "@" -e "#$"
905 }
906
907 update_contributors() {
908 echo -n "Updating list of contributors"
909
910 local contributors="$(contributors | paste -sd , - | sed -e "s/,/&\\\\n/g")"
911
912 # Edit contributors into credits.cgi
913 local tmp="$(mktemp)"
914
915 awk "/<!-- CONTRIBUTORS -->/{ p=1; print; printf \"${contributors}\n\"}/<!-- END -->/{ p=0 } !p" \
916 < "${BASEDIR}/html/cgi-bin/credits.cgi" > "${tmp}"
917
918 # Copy back modified content
919 cat "${tmp}" > "${BASEDIR}/html/cgi-bin/credits.cgi"
920 unlink "${tmp}"
921
922 print_status DONE
923 return 0
924 }
925
926 # Default settings
927 CCACHE_CACHE_SIZE="4G"
928 ENABLE_RAMDISK="auto"
929
930 # Load configuration file
931 if [ -f .config ]; then
932 . .config
933 fi
934
935 # TARGET_ARCH is BUILD_ARCH now
936 if [ -n "${TARGET_ARCH}" ]; then
937 BUILD_ARCH="${TARGET_ARCH}"
938 unset TARGET_ARCH
939 fi
940
941 # Get some information about the host system
942 SYSTEM_PROCESSORS="$(system_processors)"
943 SYSTEM_MEMORY="$(system_memory)"
944
945 if [ -n "${BUILD_ARCH}" ]; then
946 configure_build "${BUILD_ARCH}"
947 else
948 configure_build "default"
949 fi
950
951 # Automatically enable/disable ramdisk usage
952 if [ "${ENABLE_RAMDISK}" = "auto" ]; then
953 # Enable only when the host system has 4GB of RAM or more
954 if [ ${SYSTEM_MEMORY} -ge 3900 ]; then
955 ENABLE_RAMDISK="on"
956 fi
957 fi
958
959 buildtoolchain() {
960 local gcc=$(type -p gcc)
961 if [ -z "${gcc}" ]; then
962 exiterror "Could not find GCC. You will need a working build enviroment in order to build the toolchain."
963 fi
964
965 # Check ${TOOLS_DIR} symlink
966 if [ -h "${TOOLS_DIR}" ]; then
967 rm -f "${TOOLS_DIR}"
968 fi
969
970 if [ ! -e "${TOOLS_DIR}" ]; then
971 ln -s "${BASEDIR}/build${TOOLS_DIR}" "${TOOLS_DIR}"
972 fi
973
974 if [ ! -h "${TOOLS_DIR}" ]; then
975 exiterror "Could not create ${TOOLS_DIR} symbolic link"
976 fi
977
978 LOGFILE="$BASEDIR/log/_build.toolchain.log"
979 export LOGFILE
980
981 lfsmake1 stage1
982 lfsmake1 binutils PASS=1
983 lfsmake1 gcc PASS=1
984 lfsmake1 linux KCFG="-headers"
985 lfsmake1 glibc
986 lfsmake1 libxcrypt
987 lfsmake1 gcc PASS=L
988 lfsmake1 zlib
989 lfsmake1 binutils PASS=2
990 lfsmake1 gcc PASS=2
991 lfsmake1 zstd
992 lfsmake1 ccache
993 lfsmake1 tcl
994 lfsmake1 expect
995 lfsmake1 dejagnu
996 lfsmake1 pkg-config
997 lfsmake1 ncurses
998 lfsmake1 bash
999 lfsmake1 bzip2
1000 lfsmake1 automake
1001 lfsmake1 coreutils
1002 lfsmake1 diffutils
1003 lfsmake1 findutils
1004 lfsmake1 gawk
1005 lfsmake1 gettext
1006 lfsmake1 grep
1007 lfsmake1 gzip
1008 lfsmake1 m4
1009 lfsmake1 make
1010 lfsmake1 patch
1011 lfsmake1 perl
1012 lfsmake1 python3
1013 lfsmake1 sed
1014 lfsmake1 tar
1015 lfsmake1 texinfo
1016 lfsmake1 xz
1017 lfsmake1 bison
1018 lfsmake1 flex
1019 lfsmake1 fake-environ
1020 CUSTOM_PATH="${PATH}" lfsmake1 strip
1021 lfsmake1 cleanup-toolchain
1022 }
1023
1024 buildbase() {
1025 LOGFILE="$BASEDIR/log/_build.base.log"
1026 export LOGFILE
1027 lfsmake2 stage2
1028 lfsmake2 linux KCFG="-headers"
1029 lfsmake2 man-pages
1030 lfsmake2 glibc
1031 lfsmake2 tzdata
1032 lfsmake2 cleanup-toolchain
1033 lfsmake2 zlib
1034 [ "${BUILD_ARCH}" = "riscv64" ] && lfsmake2 gcc PASS=A
1035 lfsmake2 zstd
1036 lfsmake2 autoconf
1037 lfsmake2 automake
1038 lfsmake2 help2man
1039 lfsmake2 libtool
1040 lfsmake2 binutils
1041 lfsmake2 gmp
1042 lfsmake2 mpfr
1043 lfsmake2 libmpc
1044 lfsmake2 libxcrypt
1045 lfsmake2 file
1046 lfsmake2 gcc
1047 lfsmake2 attr
1048 lfsmake2 acl
1049 lfsmake2 sed
1050 lfsmake2 berkeley
1051 lfsmake2 coreutils
1052 lfsmake2 iana-etc
1053 lfsmake2 m4
1054 lfsmake2 bison
1055 lfsmake2 ncurses
1056 lfsmake2 perl
1057 lfsmake2 readline
1058 lfsmake2 bzip2
1059 lfsmake2 xz
1060 lfsmake2 lzip
1061 lfsmake2 pcre
1062 lfsmake2 pcre2
1063 lfsmake2 gettext
1064 lfsmake2 bash
1065 lfsmake2 diffutils
1066 lfsmake2 ed
1067 lfsmake2 findutils
1068 lfsmake2 flex
1069 lfsmake2 gawk
1070 lfsmake2 go
1071 lfsmake2 grep
1072 lfsmake2 groff
1073 lfsmake2 gperf
1074 lfsmake2 gzip
1075 lfsmake2 hostname
1076 lfsmake2 whois
1077 lfsmake2 kbd
1078 lfsmake2 less
1079 lfsmake2 pkg-config
1080 lfsmake2 procps
1081 lfsmake2 make
1082 lfsmake2 libpipeline
1083 lfsmake2 man
1084 lfsmake2 net-tools
1085 lfsmake2 patch
1086 lfsmake2 psmisc
1087 lfsmake2 shadow
1088 lfsmake2 sysklogd
1089 lfsmake2 sysvinit
1090 lfsmake2 tar
1091 lfsmake2 texinfo
1092 lfsmake2 util-linux
1093 lfsmake2 vim
1094 lfsmake2 e2fsprogs
1095 lfsmake2 jq
1096 }
1097
1098 buildipfire() {
1099 LOGFILE="$BASEDIR/log/_build.ipfire.log"
1100 export LOGFILE
1101 lfsmake2 configroot
1102 lfsmake2 initscripts
1103 lfsmake2 backup
1104 lfsmake2 rust
1105 lfsmake2 openssl
1106 lfsmake2 kmod
1107 lfsmake2 udev
1108 lfsmake2 popt
1109 lfsmake2 libedit
1110 lfsmake2 libusb
1111 lfsmake2 libpcap
1112 lfsmake2 ppp
1113 lfsmake2 pptp
1114 lfsmake2 unzip
1115 lfsmake2 which
1116 lfsmake2 linux-firmware
1117 lfsmake2 dvb-firmwares
1118 lfsmake2 zd1211-firmware
1119 lfsmake2 rpi-firmware
1120 lfsmake2 intel-microcode
1121 lfsmake2 pcengines-apu-firmware
1122 lfsmake2 bc
1123 lfsmake2 u-boot MKIMAGE=1
1124 lfsmake2 cpio
1125 lfsmake2 mdadm
1126 lfsmake2 dracut
1127 lfsmake2 libaio
1128 lfsmake2 lvm2
1129 lfsmake2 multipath-tools
1130 lfsmake2 freetype
1131 lfsmake2 libmnl
1132 lfsmake2 libnfnetlink
1133 lfsmake2 libnetfilter_queue
1134 lfsmake2 libnetfilter_conntrack
1135 lfsmake2 libnetfilter_cthelper
1136 lfsmake2 libnetfilter_cttimeout
1137 lfsmake2 iptables
1138 lfsmake2 iproute2
1139 lfsmake2 screen
1140 lfsmake2 elfutils
1141
1142 # Kernelbuild ... current we have no platform that need
1143 # multi kernel builds so KCFG is empty
1144 lfsmake2 linux KCFG=""
1145 lfsmake2 rtl8189es KCFG=""
1146 lfsmake2 rtl8189fs KCFG=""
1147 lfsmake2 rtl8812au KCFG=""
1148 lfsmake2 rtl8822bu KCFG=""
1149 lfsmake2 rtl8821cu KCFG=""
1150 lfsmake2 linux-initrd KCFG=""
1151
1152 lfsmake2 expat
1153 lfsmake2 libconfig
1154 lfsmake2 curl
1155 lfsmake2 libarchive
1156 lfsmake2 cmake
1157 lfsmake2 json-c
1158 lfsmake2 tcl
1159 lfsmake2 libffi
1160 lfsmake2 gdbm
1161 lfsmake2 sqlite
1162 lfsmake2 python3
1163 lfsmake2 python3-setuptools
1164 lfsmake2 ninja
1165 lfsmake2 meson
1166 lfsmake2 glib
1167 lfsmake2 libgudev
1168 lfsmake2 libgpg-error
1169 lfsmake2 libgcrypt
1170 lfsmake2 libassuan
1171 lfsmake2 nettle
1172 lfsmake2 libsodium
1173 lfsmake2 libevent2
1174 lfsmake2 apr
1175 lfsmake2 aprutil
1176 lfsmake2 unbound
1177 lfsmake2 gnutls
1178 lfsmake2 libuv
1179 lfsmake2 bind
1180 lfsmake2 dhcp
1181 lfsmake2 dhcpcd
1182 lfsmake2 boost
1183 lfsmake2 linux-atm
1184 lfsmake2 libqmi
1185 lfsmake2 pam
1186 lfsmake2 c-ares
1187 lfsmake2 rust-dissimilar
1188 lfsmake2 rust-cfg-if
1189 lfsmake2 rust-libc
1190 lfsmake2 rust-getrandom
1191 lfsmake2 rust-typenum
1192 lfsmake2 rust-version-check
1193 lfsmake2 rust-generic-array
1194 lfsmake2 rust-crypto-common
1195 lfsmake2 rust-cipher
1196 lfsmake2 rust-hex
1197 lfsmake2 rust-unicode-xid
1198 lfsmake2 rust-proc-macro2
1199 lfsmake2 rust-quote
1200 lfsmake2 rust-syn
1201 lfsmake2 rust-home
1202 lfsmake2 rust-lazy-static
1203 lfsmake2 rust-memchr
1204 lfsmake2 rust-aho-corasick
1205 lfsmake2 rust-regex-syntax
1206 lfsmake2 rust-regex
1207 lfsmake2 rust-ucd-trie
1208 lfsmake2 rust-pest
1209 lfsmake2 rust-semver-parser
1210 lfsmake2 rust-semver
1211 lfsmake2 rust-same-file
1212 lfsmake2 rust-walkdir
1213 lfsmake2 rust-dirs
1214 lfsmake2 rust-toolchain_find
1215 lfsmake2 rust-serde
1216 lfsmake2 rust-itoa
1217 lfsmake2 rust-ryu
1218 lfsmake2 rust-serde_json
1219 lfsmake2 rust-synstructure
1220 lfsmake2 rust-block-buffer
1221 lfsmake2 rust-digest
1222 lfsmake2 rust-ppv-lite86
1223 lfsmake2 rust-rand_core
1224 lfsmake2 rust-rand_core-0.4.2
1225 lfsmake2 rust-rand_core-0.3.1
1226 lfsmake2 rust-rand_chacha
1227 lfsmake2 rust-rand_hc
1228 lfsmake2 rust-rand
1229 lfsmake2 rust-rdrand
1230 lfsmake2 rust-rand-0.4
1231 lfsmake2 rust-log
1232 lfsmake2 rust-num_cpus
1233 lfsmake2 rust-crossbeam-utils
1234 lfsmake2 rust-autocfg
1235 lfsmake2 rust-memoffset
1236 lfsmake2 rust-scopeguard
1237 lfsmake2 rust-crossbeam-epoch
1238 lfsmake2 rust-crossbeam-deque
1239 lfsmake2 rust-either
1240 lfsmake2 rust-crossbeam-channel
1241 lfsmake2 rust-rayon-core
1242 lfsmake2 rust-rayon
1243 lfsmake2 rust-remove_dir_all
1244 lfsmake2 rust-tempdir
1245 lfsmake2 rust-glob
1246 lfsmake2 rust-once_cell
1247 lfsmake2 rust-termcolor
1248 lfsmake2 rust-toml
1249 lfsmake2 rust-serde_derive
1250 lfsmake2 rust-trybuild
1251 lfsmake2 rust-unindent
1252 lfsmake2 rust-proc-macro-hack
1253 lfsmake2 rust-indoc-impl
1254 lfsmake2 rust-indoc
1255 lfsmake2 rust-indoc-0.3.6
1256 lfsmake2 rust-instant
1257 lfsmake2 rust-lock_api
1258 lfsmake2 rust-smallvec
1259 lfsmake2 rust-parking_lot_core
1260 lfsmake2 rust-parking_lot
1261 lfsmake2 rust-paste-impl
1262 lfsmake2 rust-paste
1263 lfsmake2 rust-paste-0.1.18
1264 lfsmake2 rust-ctor
1265 lfsmake2 rust-ghost
1266 lfsmake2 rust-inventory-impl
1267 lfsmake2 rust-inventory
1268 lfsmake2 rust-pyo3-build-config
1269 lfsmake2 rust-pyo3-macros-backend
1270 lfsmake2 rust-pyo3-macros
1271 lfsmake2 rust-pyo3
1272 lfsmake2 rust-num-traits
1273 lfsmake2 rust-num-integer
1274 lfsmake2 rust-num_threads
1275 lfsmake2 rust-time
1276 lfsmake2 rust-iana-time-zone
1277 lfsmake2 rust-chrono
1278 lfsmake2 rust-asn1_derive
1279 lfsmake2 rust-asn1
1280 lfsmake2 rust-proc-macro-error-attr
1281 lfsmake2 rust-proc-macro-error
1282 lfsmake2 rust-Inflector
1283 lfsmake2 rust-ouroboros_macro
1284 lfsmake2 rust-aliasable
1285 lfsmake2 rust-stable_deref_trait
1286 lfsmake2 rust-ouroboros
1287 lfsmake2 rust-base64
1288 lfsmake2 rust-pem
1289 lfsmake2 gdb
1290 lfsmake2 grub
1291 lfsmake2 mandoc
1292 lfsmake2 efivar
1293 lfsmake2 efibootmgr
1294 lfsmake2 libtasn1
1295 lfsmake2 p11-kit
1296 lfsmake2 ca-certificates
1297 lfsmake2 fireinfo
1298 lfsmake2 libnet
1299 lfsmake2 libnl-3
1300 lfsmake2 libidn
1301 lfsmake2 nasm
1302 lfsmake2 libjpeg
1303 lfsmake2 openjpeg
1304 lfsmake2 libexif
1305 lfsmake2 libpng
1306 lfsmake2 libtiff
1307 lfsmake2 gd
1308 lfsmake2 slang
1309 lfsmake2 newt
1310 lfsmake2 libsmooth
1311 lfsmake2 libcap
1312 lfsmake2 libcap-ng
1313 lfsmake2 pciutils
1314 lfsmake2 usbutils
1315 lfsmake2 libxml2
1316 lfsmake2 libxslt
1317 lfsmake2 perl-BerkeleyDB
1318 lfsmake2 cyrus-sasl
1319 lfsmake2 openldap
1320 lfsmake2 apache2
1321 lfsmake2 web-user-interface
1322 lfsmake2 flag-icons
1323 lfsmake2 jquery
1324 lfsmake2 bootstrap
1325 lfsmake2 arping
1326 lfsmake2 beep
1327 lfsmake2 libssh
1328 lfsmake2 libinih
1329 lfsmake2 cdrkit
1330 lfsmake2 dosfstools
1331 lfsmake2 exfatprogs
1332 lfsmake2 reiserfsprogs
1333 lfsmake2 liburcu
1334 lfsmake2 xfsprogs
1335 lfsmake2 sysfsutils
1336 lfsmake2 fuse
1337 lfsmake2 ntfs-3g
1338 lfsmake2 ethtool
1339 lfsmake2 fcron
1340 lfsmake2 perl-ExtUtils-PkgConfig
1341 lfsmake2 perl-GD
1342 lfsmake2 perl-GD-Graph
1343 lfsmake2 perl-GD-TextUtil
1344 lfsmake2 perl-Device-SerialPort
1345 lfsmake2 perl-Device-Modem
1346 lfsmake2 perl-Apache-Htpasswd
1347 lfsmake2 perl-Parse-Yapp
1348 lfsmake2 perl-Data-UUID
1349 lfsmake2 perl-Try-Tiny
1350 lfsmake2 perl-HTTP-Message
1351 lfsmake2 perl-HTTP-Date
1352 lfsmake2 gnupg
1353 lfsmake2 hdparm
1354 lfsmake2 whatmask
1355 lfsmake2 libtirpc
1356 lfsmake2 conntrack-tools
1357 lfsmake2 iputils
1358 lfsmake2 l7-protocols
1359 lfsmake2 hwdata
1360 lfsmake2 logrotate
1361 lfsmake2 logwatch
1362 lfsmake2 misc-progs
1363 lfsmake2 nano
1364 lfsmake2 perl-URI
1365 lfsmake2 perl-CGI
1366 lfsmake2 perl-Switch
1367 lfsmake2 perl-HTML-Tagset
1368 lfsmake2 perl-HTML-Parser
1369 lfsmake2 perl-HTML-Template
1370 lfsmake2 perl-Compress-Zlib
1371 lfsmake2 perl-Digest
1372 lfsmake2 perl-Digest-SHA1
1373 lfsmake2 perl-Digest-HMAC
1374 lfsmake2 perl-libwww
1375 lfsmake2 perl-LWP-Protocol-https
1376 lfsmake2 perl-Net-HTTP
1377 lfsmake2 perl-Net-DNS
1378 lfsmake2 perl-Net-IPv4Addr
1379 lfsmake2 perl-Net_SSLeay
1380 lfsmake2 perl-IO-Stringy
1381 lfsmake2 perl-IO-Socket-SSL
1382 lfsmake2 perl-Unix-Syslog
1383 lfsmake2 perl-Mail-Tools
1384 lfsmake2 perl-MIME-Tools
1385 lfsmake2 perl-Net-Server
1386 lfsmake2 perl-Canary-Stability
1387 lfsmake2 perl-Convert-TNEF
1388 lfsmake2 perl-Convert-UUlib
1389 lfsmake2 perl-Archive-Tar
1390 lfsmake2 perl-Archive-Zip
1391 lfsmake2 perl-Text-Tabs+Wrap
1392 lfsmake2 perl-XML-Parser
1393 lfsmake2 perl-Crypt-PasswdMD5
1394 lfsmake2 perl-Net-Telnet
1395 lfsmake2 perl-JSON
1396 lfsmake2 python3-inotify
1397 lfsmake2 python3-docutils
1398 lfsmake2 python3-daemon
1399 lfsmake2 ntp
1400 lfsmake2 openssh
1401 lfsmake2 fontconfig
1402 lfsmake2 dejavu-fonts-ttf
1403 lfsmake2 ubuntu-font-family
1404 lfsmake2 freefont
1405 lfsmake2 pixman
1406 lfsmake2 cairo
1407 lfsmake2 harfbuzz
1408 lfsmake2 fribidi
1409 lfsmake2 pango
1410 lfsmake2 rrdtool
1411 lfsmake2 setup
1412 lfsmake2 jansson
1413 lfsmake2 yaml
1414 lfsmake2 libhtp
1415 lfsmake2 colm
1416 lfsmake2 ragel
1417 lfsmake2 hyperscan
1418 lfsmake2 suricata
1419 lfsmake2 ids-ruleset-sources
1420 lfsmake2 ipblocklist-sources
1421 lfsmake2 squid
1422 lfsmake2 squidguard
1423 lfsmake2 calamaris
1424 lfsmake2 tcpdump
1425 lfsmake2 traceroute
1426 lfsmake2 vlan
1427 lfsmake2 wireless
1428 lfsmake2 pakfire
1429 lfsmake2 lz4
1430 lfsmake2 lzo
1431 lfsmake2 ovpn-dco
1432 lfsmake2 openvpn
1433 lfsmake2 mpage
1434 lfsmake2 dbus
1435 lfsmake2 intltool
1436 lfsmake2 libdaemon
1437 lfsmake2 avahi
1438 lfsmake2 cups
1439 lfsmake2 lcms2
1440 lfsmake2 ghostscript
1441 lfsmake2 qpdf
1442 lfsmake2 poppler
1443 lfsmake2 poppler-data
1444 lfsmake2 cups-filters
1445 lfsmake2 epson-inkjet-printer-escpr
1446 lfsmake2 cups-pdf
1447 lfsmake2 foomatic
1448 lfsmake2 hplip
1449 lfsmake2 cifs-utils
1450 lfsmake2 krb5
1451 lfsmake2 rpcsvc-proto
1452 lfsmake2 samba
1453 lfsmake2 netatalk
1454 lfsmake2 sudo
1455 lfsmake2 mc
1456 lfsmake2 wget
1457 lfsmake2 bridge-utils
1458 lfsmake2 smartmontools
1459 lfsmake2 htop
1460 lfsmake2 chkconfig
1461 lfsmake2 postfix
1462 lfsmake2 fetchmail
1463 lfsmake2 clamav
1464 lfsmake2 perl-NetAddr-IP
1465 lfsmake2 dma
1466 lfsmake2 alsa
1467 lfsmake2 mpfire
1468 lfsmake2 guardian
1469 lfsmake2 libid3tag
1470 lfsmake2 libmad
1471 lfsmake2 libogg
1472 lfsmake2 libvorbis
1473 lfsmake2 flac
1474 lfsmake2 lame
1475 lfsmake2 sox
1476 lfsmake2 soxr
1477 lfsmake2 libshout
1478 lfsmake2 xvid
1479 lfsmake2 libmpeg2
1480 lfsmake2 gnump3d
1481 lfsmake2 rsync
1482 lfsmake2 rpcbind
1483 lfsmake2 keyutils
1484 lfsmake2 nfs
1485 lfsmake2 ncat
1486 lfsmake2 nmap
1487 lfsmake2 etherwake
1488 lfsmake2 bwm-ng
1489 lfsmake2 sysstat
1490 lfsmake2 strongswan
1491 lfsmake2 rng-tools
1492 lfsmake2 lsof
1493 lfsmake2 br2684ctl
1494 lfsmake2 lm_sensors
1495 lfsmake2 libstatgrab
1496 lfsmake2 liboping
1497 lfsmake2 collectd
1498 lfsmake2 git
1499 lfsmake2 elinks
1500 lfsmake2 igmpproxy
1501 lfsmake2 opus
1502 lfsmake2 python3-toml
1503 lfsmake2 python3-pyproject2setuppy
1504 lfsmake2 python3-pyparsing
1505 lfsmake2 spice-protocol
1506 lfsmake2 spice
1507 lfsmake2 sdl2
1508 lfsmake2 libusbredir
1509 lfsmake2 libseccomp
1510 lfsmake2 qemu
1511 lfsmake2 netsnmpd
1512 lfsmake2 nagios_nrpe
1513 lfsmake2 nagios-plugins
1514 lfsmake2 icinga
1515 lfsmake2 observium-agent
1516 lfsmake2 ebtables
1517 lfsmake2 faad2
1518 lfsmake2 alac
1519 lfsmake2 ffmpeg
1520 lfsmake2 vdr
1521 lfsmake2 vdr_streamdev
1522 lfsmake2 vdr_epgsearch
1523 lfsmake2 vdr_dvbapi
1524 lfsmake2 vdr_eepg
1525 lfsmake2 w_scan
1526 lfsmake2 fmt
1527 lfsmake2 mpd
1528 lfsmake2 libmpdclient
1529 lfsmake2 mpc
1530 lfsmake2 perl-Net-CIDR-Lite
1531 lfsmake2 perl-Net-SMTP-SSL
1532 lfsmake2 perl-MIME-Base64
1533 lfsmake2 perl-Authen-SASL
1534 lfsmake2 perl-MIME-Lite
1535 lfsmake2 perl-Email-Date-Format
1536 lfsmake2 squidclamav
1537 lfsmake2 vnstat
1538 lfsmake2 iw
1539 lfsmake2 wpa_supplicant
1540 lfsmake2 hostapd
1541 lfsmake2 syslinux
1542 lfsmake2 tftpd
1543 lfsmake2 cpufrequtils
1544 lfsmake2 gutenprint
1545 lfsmake2 apcupsd
1546 lfsmake2 fireperf
1547 lfsmake2 iperf
1548 lfsmake2 iperf3
1549 lfsmake2 7zip
1550 lfsmake2 lynis
1551 lfsmake2 sshfs
1552 lfsmake2 taglib
1553 lfsmake2 sslh
1554 lfsmake2 perl-gettext
1555 lfsmake2 perl-Sort-Naturally
1556 lfsmake2 vdradmin
1557 lfsmake2 perl-DBI
1558 lfsmake2 perl-DBD-SQLite
1559 lfsmake2 perl-File-ReadBackwards
1560 lfsmake2 openvmtools
1561 lfsmake2 joe
1562 lfsmake2 monit
1563 lfsmake2 nut
1564 lfsmake2 watchdog
1565 lfsmake2 usb_modeswitch
1566 lfsmake2 usb_modeswitch_data
1567 lfsmake2 zerofree
1568 lfsmake2 minicom
1569 lfsmake2 ddrescue
1570 lfsmake2 powertop
1571 lfsmake2 parted
1572 lfsmake2 swig
1573 lfsmake2 dtc
1574 lfsmake2 u-boot
1575 lfsmake2 wireless-regdb
1576 lfsmake2 ddns
1577 lfsmake2 python3-pycparser
1578 lfsmake2 python3-charset-normalizer
1579 lfsmake2 python3-certifi
1580 lfsmake2 python3-idna
1581 lfsmake2 python3-requests
1582 lfsmake2 python3-tomli
1583 lfsmake2 python3-pep517
1584 lfsmake2 python3-build
1585 lfsmake2 python3-install
1586 lfsmake2 python3-urllib3
1587 lfsmake2 python3-flit
1588 lfsmake2 python3-packaging
1589 lfsmake2 python3-typing-extensions
1590 lfsmake2 python3-semantic-version
1591 lfsmake2 python3-setuptools-scm
1592 lfsmake2 python3-setuptools-rust
1593 lfsmake2 python3-six
1594 lfsmake2 python3-dateutil
1595 lfsmake2 python3-jmespath
1596 lfsmake2 python3-colorama
1597 lfsmake2 python3-yaml
1598 lfsmake2 python3-s3transfer
1599 lfsmake2 python3-rsa
1600 lfsmake2 python3-pyasn1
1601 lfsmake2 python3-botocore
1602 lfsmake2 python3-cffi
1603 lfsmake2 python3-cryptography
1604 lfsmake2 python3-circuitbreaker
1605 lfsmake2 python3-pytz
1606 lfsmake2 python3-click
1607 lfsmake2 python3-arrow
1608 lfsmake2 python3-terminaltables
1609 lfsmake2 python3-pkgconfig
1610 lfsmake2 python3-msgpack
1611 lfsmake2 python3-attr
1612 lfsmake2 python3-attrs
1613 lfsmake2 python3-sniffio
1614 lfsmake2 python3-sortedcontainers
1615 lfsmake2 python3-outcome
1616 lfsmake2 python3-async_generator
1617 lfsmake2 python3-trio
1618 lfsmake2 python3-pyfuse3
1619 lfsmake2 aws-cli
1620 lfsmake2 oci-python-sdk
1621 lfsmake2 oci-cli
1622 lfsmake2 transmission
1623 lfsmake2 mtr
1624 lfsmake2 minidlna
1625 lfsmake2 acpid
1626 lfsmake2 fping
1627 lfsmake2 telnet
1628 lfsmake2 xinetd
1629 lfsmake2 stress
1630 lfsmake2 sarg
1631 lfsmake2 nginx
1632 lfsmake2 sysbench
1633 lfsmake2 strace
1634 lfsmake2 ltrace
1635 lfsmake2 ipfire-netboot
1636 lfsmake2 lcdproc
1637 lfsmake2 keepalived
1638 lfsmake2 ipvsadm
1639 lfsmake2 perl-Carp-Clan
1640 lfsmake2 perl-Date-Calc
1641 lfsmake2 perl-Date-Manip
1642 lfsmake2 perl-File-Tail
1643 lfsmake2 perl-TimeDate
1644 lfsmake2 swatch
1645 lfsmake2 tor
1646 lfsmake2 wavemon
1647 lfsmake2 iptraf-ng
1648 lfsmake2 iotop
1649 lfsmake2 stunnel
1650 lfsmake2 bacula
1651 lfsmake2 perl-Font-TTF
1652 lfsmake2 perl-IO-String
1653 lfsmake2 perl-PDF-API2
1654 lfsmake2 proxy-accounting
1655 lfsmake2 tmux
1656 lfsmake2 perl-Text-CSV_XS
1657 lfsmake2 lua
1658 lfsmake2 haproxy
1659 lfsmake2 ipset
1660 lfsmake2 dnsdist
1661 lfsmake2 bird
1662 lfsmake2 libyang
1663 lfsmake2 frr
1664 lfsmake2 dmidecode
1665 lfsmake2 mcelog
1666 lfsmake2 libpciaccess
1667 lfsmake2 libyajl
1668 lfsmake2 libvirt
1669 lfsmake2 libtalloc
1670 lfsmake2 freeradius
1671 lfsmake2 perl-common-sense
1672 lfsmake2 perl-inotify2
1673 lfsmake2 perl-Net-IP
1674 lfsmake2 wio
1675 lfsmake2 iftop
1676 lfsmake2 mdns-repeater
1677 lfsmake2 i2c-tools
1678 lfsmake2 nss-myhostname
1679 lfsmake2 dehydrated
1680 lfsmake2 libplist
1681 lfsmake2 nqptp
1682 lfsmake2 shairport-sync
1683 lfsmake2 borgbackup
1684 lfsmake2 lmdb
1685 lfsmake2 knot
1686 lfsmake2 spectre-meltdown-checker
1687 lfsmake2 zabbix_agentd
1688 lfsmake2 flashrom
1689 lfsmake2 firmware-update
1690 lfsmake2 tshark
1691 lfsmake2 speedtest-cli
1692 lfsmake2 amazon-ssm-agent
1693 lfsmake2 libloc
1694 lfsmake2 ncdu
1695 lfsmake2 lshw
1696 lfsmake2 socat
1697 lfsmake2 libcdada
1698 lfsmake2 pmacct
1699 lfsmake2 squid-asnbl
1700 lfsmake2 qemu-ga
1701 lfsmake2 gptfdisk
1702 lfsmake2 oath-toolkit
1703 lfsmake2 qrencode
1704 lfsmake2 perl-File-Remove
1705 lfsmake2 perl-Module-Build
1706 lfsmake2 perl-Module-ScanDeps
1707 lfsmake2 perl-YAML-Tiny
1708 lfsmake2 perl-Module-Install
1709 lfsmake2 perl-Imager
1710 lfsmake2 perl-Imager-QRCode
1711 lfsmake2 perl-MIME-Base32
1712 lfsmake2 perl-URI-Encode
1713 }
1714
1715 buildinstaller() {
1716 # Run installer scripts one by one
1717 LOGFILE="$BASEDIR/log/_build.installer.log"
1718 export LOGFILE
1719 lfsmake2 memtest
1720 lfsmake2 installer
1721 # use toolchain bash for chroot to strip
1722 CUSTOM_PATH="${TOOLS_DIR}/bin" lfsmake2 strip
1723 }
1724
1725 buildpackages() {
1726 LOGFILE="$BASEDIR/log/_build.packages.log"
1727 export LOGFILE
1728 echo "... see detailed log in _build.*.log files" >> $LOGFILE
1729
1730
1731 # Generating list of packages used
1732 print_line "Generating packages list from logs"
1733 rm -f $BASEDIR/doc/packages-list
1734 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
1735 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
1736 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
1737 fi
1738 done
1739 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
1740 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
1741 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
1742 rm -f $BASEDIR/doc/packages-list
1743 # packages-list.txt is ready to be displayed for wiki page
1744 print_status DONE
1745
1746 # Update changelog
1747 cd $BASEDIR
1748 [ -z $GIT_TAG ] || LAST_TAG=$GIT_TAG
1749 [ -z $LAST_TAG ] || EXT="$LAST_TAG..HEAD"
1750 git log -n 500 --no-merges --pretty=medium --shortstat $EXT > $BASEDIR/doc/ChangeLog
1751
1752 # Create images for install
1753 lfsmake2 cdrom
1754
1755 # Check if there is a loop device for building in virtual environments
1756 modprobe loop 2>/dev/null
1757 if [ $BUILD_IMAGES == 1 ] && ([ -e /dev/loop/0 ] || [ -e /dev/loop0 ] || [ -e "/dev/loop-control" ]); then
1758 lfsmake2 flash-images
1759 fi
1760
1761 mv $LFS/install/images/{*.iso,*.img.xz,*.bz2} $BASEDIR >> $LOGFILE 2>&1
1762
1763 ipfirepackages
1764
1765 cd $BASEDIR
1766
1767 for i in $(ls *.bz2 *.img.xz *.iso 2>/dev/null); do
1768 b2sum $i > $i.b2
1769 done
1770 cd $PWD
1771
1772 # Cleanup
1773 stdumount
1774 rm -rf $BASEDIR/build/tmp/*
1775
1776 cd $PWD
1777 }
1778
1779 ipfirepackages() {
1780 lfsmake2 core-updates
1781
1782 local i
1783 for i in $(find $BASEDIR/config/rootfiles/packages{/${BUILD_ARCH},} -maxdepth 1 -type f); do
1784 i=$(basename ${i})
1785 if [ -e $BASEDIR/lfs/$i ]; then
1786 ipfiredist $i
1787 else
1788 echo -n $i
1789 print_status SKIP
1790 fi
1791 done
1792 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
1793 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
1794 rm -rf $BASEDIR/build/install/packages/*
1795 }
1796
1797 while [ $# -gt 0 ]; do
1798 case "${1}" in
1799 --target=*)
1800 configure_build "${1#--target=}"
1801 ;;
1802 -*)
1803 exiterror "Unknown configuration option: ${1}"
1804 ;;
1805 *)
1806 # Found a command, so exit options parsing.
1807 break
1808 ;;
1809 esac
1810 shift
1811 done
1812
1813 # See what we're supposed to do
1814 case "$1" in
1815 build)
1816 START_TIME="${SECONDS}"
1817
1818 PACKAGE="$BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.zst"
1819 #only restore on a clean disk
1820 if [ ! -e "${BASEDIR}/build${TOOLS_DIR}/.toolchain-successful" ]; then
1821 if [ ! -n "$PACKAGE" ]; then
1822 print_build_stage "Full toolchain compilation"
1823 prepareenv
1824 buildtoolchain
1825 else
1826 PACKAGENAME=${PACKAGE%.tar.zst}
1827 print_build_stage "Packaged toolchain compilation"
1828 if [ `b2sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.b2 | awk '{print $1}'` ]; then
1829 zstd -d < "${PACKAGE}" | tar x
1830 prepareenv
1831 else
1832 exiterror "$PACKAGENAME BLAKE2 checksum did not match, check downloaded package"
1833 fi
1834 fi
1835 else
1836 prepareenv
1837 fi
1838
1839 print_build_stage "Building LFS"
1840 buildbase
1841
1842 print_build_stage "Building IPFire"
1843 buildipfire
1844
1845 print_build_stage "Building installer"
1846 buildinstaller
1847
1848 print_build_stage "Building packages"
1849 buildpackages
1850
1851 print_build_stage "Checking Logfiles for new Files"
1852
1853 cd $BASEDIR
1854 tools/checknewlog.pl
1855 tools/checkrootfiles
1856 cd $PWD
1857
1858 print_build_summary $(( SECONDS - START_TIME ))
1859 ;;
1860 shell)
1861 # enter a shell inside LFS chroot
1862 # may be used to changed kernel settings
1863 prepareenv
1864 entershell
1865 ;;
1866 clean)
1867 print_line "Cleaning build directory..."
1868
1869 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
1870 $LOSETUP -d $i 2>/dev/null
1871 done
1872 #for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
1873 # umount $i
1874 #done
1875 stdumount
1876 for i in `seq 0 7`; do
1877 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
1878 umount /dev/loop${i} 2>/dev/null;
1879 losetup -d /dev/loop${i} 2>/dev/null;
1880 fi;
1881 done
1882 rm -rf $BASEDIR/build
1883 rm -rf $BASEDIR/cdrom
1884 rm -rf $BASEDIR/packages
1885 rm -rf $BASEDIR/log
1886 if [ -h "${TOOLS_DIR}" ]; then
1887 rm -f "${TOOLS_DIR}"
1888 fi
1889 rm -f $BASEDIR/ipfire-*
1890 print_status DONE
1891 ;;
1892 docker)
1893 # Build the docker image if it does not exist, yet
1894 if ! docker images -a | grep -q ^ipfire-builder; then
1895 if docker build -t ipfire-builder ${BASEDIR}/tools/docker; then
1896 print_status DONE
1897 else
1898 print_status FAIL
1899 exit 1
1900 fi
1901 fi
1902
1903 # Run the container and enter a shell
1904 docker run -it --privileged -v "${BASEDIR}:/build" -w "/build" ipfire-builder bash -l
1905 ;;
1906 downloadsrc)
1907 if [ ! -d $BASEDIR/cache ]; then
1908 mkdir $BASEDIR/cache
1909 fi
1910 mkdir -p $BASEDIR/log
1911 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
1912 FINISHED=0
1913 cd $BASEDIR/lfs
1914 for c in `seq $MAX_RETRIES`; do
1915 if (( FINISHED==1 )); then
1916 break
1917 fi
1918 FINISHED=1
1919 cd $BASEDIR/lfs
1920 for i in *; do
1921 if [ -f "$i" -a "$i" != "Config" ]; then
1922 lfsmakecommoncheck ${i} || continue
1923
1924 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
1925 MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
1926 if [ $? -ne 0 ]; then
1927 print_status FAIL
1928 FINISHED=0
1929 else
1930 if [ $c -eq 1 ]; then
1931 print_status DONE
1932 fi
1933 fi
1934 fi
1935 done
1936 done
1937 echo -e "${BOLD}***Verifying BLAKE2 checksum${NORMAL}"
1938 ERROR=0
1939 for i in *; do
1940 if [ -f "$i" -a "$i" != "Config" ]; then
1941 lfsmakecommoncheck ${i} > /dev/null || continue
1942 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
1943 MESSAGE="$i\t " b2 >> $LOGFILE 2>&1
1944 if [ $? -ne 0 ]; then
1945 echo -ne "BLAKE2 checksum difference in lfs/$i"
1946 print_status FAIL
1947 ERROR=1
1948 fi
1949 fi
1950 done
1951 if [ $ERROR -eq 0 ]; then
1952 echo -ne "${BOLD}all files BLAKE2 checksum match${NORMAL}"
1953 print_status DONE
1954 else
1955 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
1956 print_status FAIL
1957 fi
1958 cd - >/dev/null 2>&1
1959 ;;
1960 toolchain)
1961 prepareenv
1962 print_build_stage "Toolchain compilation (${BUILD_ARCH})"
1963 buildtoolchain
1964 echo "`date -u '+%b %e %T'`: Create toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
1965 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
1966 cd $BASEDIR && tar -cf- --exclude='log/_build.*.log' build/${TOOLS_DIR} build/bin/sh log \
1967 | zstd ${ZSTD_OPT} > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.zst
1968 b2sum cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.zst \
1969 > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.b2
1970 stdumount
1971 ;;
1972 gettoolchain)
1973 # arbitrary name to be updated in case of new toolchain package upload
1974 PACKAGE=$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}
1975 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.zst ]; then
1976 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
1977 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
1978 echo "`date -u '+%b %e %T'`: Load toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
1979 cd $BASEDIR/cache/toolchains
1980 wget -U "IPFireSourceGrabber/2.x" $URL_TOOLCHAIN/$PACKAGE.tar.zst $URL_TOOLCHAIN/$PACKAGE.b2 >& /dev/null
1981 if [ $? -ne 0 ]; then
1982 echo "`date -u '+%b %e %T'`: error downloading $PACKAGE toolchain for ${BUILD_ARCH} machine" | tee -a $LOGFILE
1983 else
1984 if [ "`b2sum $PACKAGE.tar.zst | awk '{print $1}'`" = "`cat $PACKAGE.b2 | awk '{print $1}'`" ]; then
1985 echo "`date -u '+%b %e %T'`: toolchain BLAKE2 checksum ok" | tee -a $LOGFILE
1986 else
1987 exiterror "$PACKAGE BLAKE2 checksum did not match, check downloaded package"
1988 fi
1989 fi
1990 else
1991 echo "Toolchain is already downloaded. Exiting..."
1992 fi
1993 ;;
1994 uploadsrc)
1995 if [ -z $IPFIRE_USER ]; then
1996 echo -n "You have to setup IPFIRE_USER first. See .config for details."
1997 print_status FAIL
1998 exit 1
1999 fi
2000
2001 URL_SOURCE="$(awk '/^URL_SOURCE/ { print $3 }' lfs/Config)"
2002
2003 rsync \
2004 --recursive \
2005 --update \
2006 --ignore-existing \
2007 --progress \
2008 --human-readable \
2009 --exclude="toolchains/" \
2010 "${BASEDIR}/cache/" \
2011 "${IPFIRE_USER}@${URL_SOURCE}"
2012
2013 exit 0
2014 ;;
2015 lang)
2016 echo -ne "Checking the translations for missing or obsolete strings..."
2017 chmod 755 $BASEDIR/tools/{check_strings.pl,sort_strings.pl,check_langs.sh}
2018 $BASEDIR/tools/sort_strings.pl en
2019 $BASEDIR/tools/sort_strings.pl de
2020 $BASEDIR/tools/sort_strings.pl fr
2021 $BASEDIR/tools/sort_strings.pl es
2022 $BASEDIR/tools/sort_strings.pl pl
2023 $BASEDIR/tools/sort_strings.pl ru
2024 $BASEDIR/tools/sort_strings.pl nl
2025 $BASEDIR/tools/sort_strings.pl tr
2026 $BASEDIR/tools/sort_strings.pl it
2027 $BASEDIR/tools/check_strings.pl en > $BASEDIR/doc/language_issues.en
2028 $BASEDIR/tools/check_strings.pl de > $BASEDIR/doc/language_issues.de
2029 $BASEDIR/tools/check_strings.pl fr > $BASEDIR/doc/language_issues.fr
2030 $BASEDIR/tools/check_strings.pl es > $BASEDIR/doc/language_issues.es
2031 $BASEDIR/tools/check_strings.pl pl > $BASEDIR/doc/language_issues.pl
2032 $BASEDIR/tools/check_strings.pl ru > $BASEDIR/doc/language_issues.ru
2033 $BASEDIR/tools/check_strings.pl nl > $BASEDIR/doc/language_issues.nl
2034 $BASEDIR/tools/check_strings.pl tr > $BASEDIR/doc/language_issues.tr
2035 $BASEDIR/tools/check_strings.pl it > $BASEDIR/doc/language_issues.it
2036 $BASEDIR/tools/check_langs.sh > $BASEDIR/doc/language_missings
2037 print_status DONE
2038
2039 echo -ne "Updating language lists..."
2040 update_language_list ${BASEDIR}/src/installer/po
2041 update_language_list ${BASEDIR}/src/setup/po
2042 print_status DONE
2043 ;;
2044 update-contributors)
2045 update_contributors
2046 ;;
2047 find-dependencies)
2048 shift
2049 exec "${BASEDIR}/tools/find-dependencies" "${BASEDIR}/build" "$@"
2050 ;;
2051 check-manualpages)
2052 echo "Checking the manual pages for broken links..."
2053
2054 chmod 755 $BASEDIR/tools/check_manualpages.pl
2055 if $BASEDIR/tools/check_manualpages.pl; then
2056 print_status DONE
2057 else
2058 print_status FAIL
2059 fi
2060 ;;
2061 *)
2062 echo "Usage: $0 [OPTIONS] {build|check-manualpages|clean|docker|downloadsrc|find-dependencies|gettoolchain|lang|shell|toolchain|update-contributors|uploadsrc}"
2063 cat doc/make.sh-usage
2064 ;;
2065 esac